--- configure~	2019-05-27 23:04:02.000000000 +0200
+++ configure	2019-06-12 21:52:30.000000000 +0200
@@ -870,11 +870,6 @@
 with_zlib
 with_bzip2
 with_fam
-with_webdav_props
-with_libxml
-with_sqlite
-with_webdav_locks
-with_uuid
 with_gdbm
 with_geoip
 with_maxminddb
@@ -1586,11 +1581,6 @@
   --with-zlib             Enable zlib support for mod_compress
   --with-bzip2            Enable bzip2 support for mod_compress
   --with-fam              fam/gamin for reducing number of stat() calls
-  --with-webdav-props     properties in mod_webdav
-  --with-libxml           libxml2 for properties in mod_webdav
-  --with-sqlite           sqlite for properties in mod_webdav
-  --with-webdav-locks     locks in mod_webdav (requires webdav properties)
-  --with-uuid             uuid for locks in mod_webdav
   --with-gdbm             gdbm storage for mod_trigger_b4_dl
   --with-geoip            IP-based geolocation lookup
   --with-maxminddb        IP-based geolocation lookup
@@ -17253,352 +17243,6 @@
 fi
 
 
-{ $as_echo "$as_me:${as_lineno-$LINENO}: ----------------------------------------" >&5
-$as_echo "$as_me: ----------------------------------------" >&6;}
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for properties in mod_webdav" >&5
-$as_echo_n "checking for properties in mod_webdav... " >&6; }
-
-# Check whether --with-webdav-props was given.
-if test "${with_webdav_props+set}" = set; then :
-  withval=$with_webdav_props; WITH_WEBDAV_PROPS=$withval
-else
-  WITH_WEBDAV_PROPS=no
-
-fi
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $WITH_WEBDAV_PROPS" >&5
-$as_echo "$WITH_WEBDAV_PROPS" >&6; }
-
-if test "$WITH_WEBDAV_PROPS" != no; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for libxml2" >&5
-$as_echo_n "checking for libxml2... " >&6; }
-
-# Check whether --with-libxml was given.
-if test "${with_libxml+set}" = set; then :
-  withval=$with_libxml; WITH_LIBXML=$withval
-else
-  WITH_LIBXML=yes
-
-fi
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $WITH_LIBXML" >&5
-$as_echo "$WITH_LIBXML" >&6; }
-
-  if test "$WITH_LIBXML" = no; then
-    as_fn_error $? "--with-webdav-props requires libxml" "$LINENO" 5
-  fi
-
-  if test "$WITH_LIBXML" != yes; then
-    XML_LIBS="-L$WITH_LIBXML/.libs -lxml2"
-    XML_CFLAGS="-I$WITH_LIBXML/include"
-  else
-
-pkg_failed=no
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for XML" >&5
-$as_echo_n "checking for XML... " >&6; }
-
-if test -n "$XML_CFLAGS"; then
-    pkg_cv_XML_CFLAGS="$XML_CFLAGS"
- elif test -n "$PKG_CONFIG"; then
-    if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libxml-2.0\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "libxml-2.0") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then
-  pkg_cv_XML_CFLAGS=`$PKG_CONFIG --cflags "libxml-2.0" 2>/dev/null`
-		      test "x$?" != "x0" && pkg_failed=yes
-else
-  pkg_failed=yes
-fi
- else
-    pkg_failed=untried
-fi
-if test -n "$XML_LIBS"; then
-    pkg_cv_XML_LIBS="$XML_LIBS"
- elif test -n "$PKG_CONFIG"; then
-    if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"libxml-2.0\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "libxml-2.0") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then
-  pkg_cv_XML_LIBS=`$PKG_CONFIG --libs "libxml-2.0" 2>/dev/null`
-		      test "x$?" != "x0" && pkg_failed=yes
-else
-  pkg_failed=yes
-fi
- else
-    pkg_failed=untried
-fi
-
-
-
-if test $pkg_failed = yes; then
-   	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-
-if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
-        _pkg_short_errors_supported=yes
-else
-        _pkg_short_errors_supported=no
-fi
-        if test $_pkg_short_errors_supported = yes; then
-	        XML_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "libxml-2.0" 2>&1`
-        else
-	        XML_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "libxml-2.0" 2>&1`
-        fi
-	# Put the nasty error message in config.log where it belongs
-	echo "$XML_PKG_ERRORS" >&5
-
-
-      as_fn_error $? "libxml2 not found, install it or build without --with-webdav-props" "$LINENO" 5
-
-elif test $pkg_failed = untried; then
-     	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-
-      as_fn_error $? "libxml2 not found, install it or build without --with-webdav-props" "$LINENO" 5
-
-else
-	XML_CFLAGS=$pkg_cv_XML_CFLAGS
-	XML_LIBS=$pkg_cv_XML_LIBS
-        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
-$as_echo "yes" >&6; }
-
-fi
-  fi
-
-
-$as_echo "#define HAVE_LIBXML2 1" >>confdefs.h
-
-
-$as_echo "#define HAVE_LIBXML_H 1" >>confdefs.h
-
-
-
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for sqlite" >&5
-$as_echo_n "checking for sqlite... " >&6; }
-
-# Check whether --with-sqlite was given.
-if test "${with_sqlite+set}" = set; then :
-  withval=$with_sqlite; WITH_SQLITE=$withval
-else
-  WITH_SQLITE=yes
-
-fi
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $WITH_SQLITE" >&5
-$as_echo "$WITH_SQLITE" >&6; }
-
-  if test "$WITH_SQLITE" = no; then
-    as_fn_error $? "--with-webdav-props requires sqlite" "$LINENO" 5
-  fi
-
-  if test "$WITH_SQLITE" != yes; then
-    SQLITE_LIBS="-L$WITH_SQLITE/.libs -lsqlite3"
-    SQLITE_CFLAGS="-I$WITH_SQLITE"
-  else
-
-pkg_failed=no
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for SQLITE" >&5
-$as_echo_n "checking for SQLITE... " >&6; }
-
-if test -n "$SQLITE_CFLAGS"; then
-    pkg_cv_SQLITE_CFLAGS="$SQLITE_CFLAGS"
- elif test -n "$PKG_CONFIG"; then
-    if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"sqlite3\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "sqlite3") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then
-  pkg_cv_SQLITE_CFLAGS=`$PKG_CONFIG --cflags "sqlite3" 2>/dev/null`
-		      test "x$?" != "x0" && pkg_failed=yes
-else
-  pkg_failed=yes
-fi
- else
-    pkg_failed=untried
-fi
-if test -n "$SQLITE_LIBS"; then
-    pkg_cv_SQLITE_LIBS="$SQLITE_LIBS"
- elif test -n "$PKG_CONFIG"; then
-    if test -n "$PKG_CONFIG" && \
-    { { $as_echo "$as_me:${as_lineno-$LINENO}: \$PKG_CONFIG --exists --print-errors \"sqlite3\""; } >&5
-  ($PKG_CONFIG --exists --print-errors "sqlite3") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then
-  pkg_cv_SQLITE_LIBS=`$PKG_CONFIG --libs "sqlite3" 2>/dev/null`
-		      test "x$?" != "x0" && pkg_failed=yes
-else
-  pkg_failed=yes
-fi
- else
-    pkg_failed=untried
-fi
-
-
-
-if test $pkg_failed = yes; then
-   	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-
-if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
-        _pkg_short_errors_supported=yes
-else
-        _pkg_short_errors_supported=no
-fi
-        if test $_pkg_short_errors_supported = yes; then
-	        SQLITE_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors --cflags --libs "sqlite3" 2>&1`
-        else
-	        SQLITE_PKG_ERRORS=`$PKG_CONFIG --print-errors --cflags --libs "sqlite3" 2>&1`
-        fi
-	# Put the nasty error message in config.log where it belongs
-	echo "$SQLITE_PKG_ERRORS" >&5
-
-
-      as_fn_error $? "sqlite3 not found, install it or build without --with-webdav-props" "$LINENO" 5
-
-elif test $pkg_failed = untried; then
-     	{ $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-
-      as_fn_error $? "sqlite3 not found, install it or build without --with-webdav-props" "$LINENO" 5
-
-else
-	SQLITE_CFLAGS=$pkg_cv_SQLITE_CFLAGS
-	SQLITE_LIBS=$pkg_cv_SQLITE_LIBS
-        { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
-$as_echo "yes" >&6; }
-
-fi
-  fi
-
-
-$as_echo "#define HAVE_SQLITE3 1" >>confdefs.h
-
-
-$as_echo "#define HAVE_SQLITE3_H 1" >>confdefs.h
-
-
-
-fi
-
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: ----------------------------------------" >&5
-$as_echo "$as_me: ----------------------------------------" >&6;}
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for locks in mod_webdav" >&5
-$as_echo_n "checking for locks in mod_webdav... " >&6; }
-
-# Check whether --with-webdav-locks was given.
-if test "${with_webdav_locks+set}" = set; then :
-  withval=$with_webdav_locks; WITH_WEBDAV_LOCKS=$withval
-else
-  WITH_WEBDAV_LOCKS=no
-
-fi
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $WITH_WEBDAV_LOCKS" >&5
-$as_echo "$WITH_WEBDAV_LOCKS" >&6; }
-
-if test "$WITH_WEBDAV_LOCKS" != no; then
-  if test "$WITH_WEBDAV_PROPS" = no; then
-    as_fn_error $? "--with-webdav-locks requires --with-webdav-props" "$LINENO" 5
-  fi
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for libuuid" >&5
-$as_echo_n "checking for libuuid... " >&6; }
-
-# Check whether --with-uuid was given.
-if test "${with_uuid+set}" = set; then :
-  withval=$with_uuid; WITH_UUID=$withval
-else
-  WITH_UUID=yes
-
-fi
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $WITH_UUID" >&5
-$as_echo "$WITH_UUID" >&6; }
-
-  if test "$WITH_UUID" = no; then
-    as_fn_error $? "--with-webdav-locks requires uuid" "$LINENO" 5
-  fi
-
-  if test "$WITH_UUID" != yes; then
-    UUID_LIBS="-L$WITH_UUID -luuid"
-    CPPFLAGS="$CPPFLAGS -I$WITH_UUID"
-  else
-    { $as_echo "$as_me:${as_lineno-$LINENO}: checking for uuid_unparse in -luuid" >&5
-$as_echo_n "checking for uuid_unparse in -luuid... " >&6; }
-if ${ac_cv_lib_uuid_uuid_unparse+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-luuid  $LIBS"
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char uuid_unparse ();
-int
-main ()
-{
-return uuid_unparse ();
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_lib_uuid_uuid_unparse=yes
-else
-  ac_cv_lib_uuid_uuid_unparse=no
-fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_uuid_uuid_unparse" >&5
-$as_echo "$ac_cv_lib_uuid_uuid_unparse" >&6; }
-if test "x$ac_cv_lib_uuid_uuid_unparse" = xyes; then :
-  UUID_LIBS=-luuid
-else
-  as_fn_error $? "uuid lib not found, install it or build without --with-webdav-locks" "$LINENO" 5
-
-fi
-
-    for ac_header in uuid/uuid.h
-do :
-  ac_fn_c_check_header_mongrel "$LINENO" "uuid/uuid.h" "ac_cv_header_uuid_uuid_h" "$ac_includes_default"
-if test "x$ac_cv_header_uuid_uuid_h" = xyes; then :
-  cat >>confdefs.h <<_ACEOF
-#define HAVE_UUID_UUID_H 1
-_ACEOF
-
-else
-  as_fn_error $? "uuid headers not found, install them or build without --with-webdav-locks" "$LINENO" 5
-
-fi
-
-done
-
-  fi
-
-
-$as_echo "#define HAVE_LIBUUID 1" >>confdefs.h
-
-
-$as_echo "#define HAVE_UUID_UUID_H 1" >>confdefs.h
-
-
-fi
 
 { $as_echo "$as_me:${as_lineno-$LINENO}: ----------------------------------------" >&5
 $as_echo "$as_me: ----------------------------------------" >&6;}
@@ -21365,7 +21009,6 @@
   mod_userdir \
   mod_usertrack \
   mod_vhostdb \
-  mod_webdav \
   mod_wstunnel \
 "
 
@@ -21439,12 +21082,6 @@
 lighty_track_feature "stat-cache-fam" "" \
   'test "$WITH_FAM" != no'
 
-lighty_track_feature "webdav-properties" "" \
-  'test "$WITH_WEBDAV_PROPS" != no'
-
-lighty_track_feature "webdav-locks" "" \
-  'test "$WITH_WEBDAV_LOCKS" != no'
-
 
 $ECHO
 $ECHO "Plugins:"