diff -Nur gcc/configure.orig gcc/configure
--- gcc/configure.orig	2020-07-23 08:35:17.000000000 +0200
+++ gcc/configure	2020-08-01 14:51:35.000000000 +0200
@@ -15500,6 +15500,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libatomic/configure.orig libatomic/configure
--- libatomic/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libatomic/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7604,6 +7604,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libbacktrace/configure.orig libbacktrace/configure
--- libbacktrace/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libbacktrace/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7983,6 +7983,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libcc1/configure.orig libcc1/configure
--- libcc1/configure.orig	2020-07-23 08:35:18.000000000 +0200
+++ libcc1/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7265,6 +7265,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libffi/configure.orig libffi/configure
--- libffi/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libffi/configure	2020-08-01 14:51:36.000000000 +0200
@@ -7777,6 +7777,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libgfortran/configure.orig libgfortran/configure
--- libgfortran/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libgfortran/configure	2020-08-01 14:51:35.000000000 +0200
@@ -9178,6 +9178,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libgo/configure.orig libgo/configure
--- libgo/configure.orig	2020-07-23 08:35:18.000000000 +0200
+++ libgo/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7621,6 +7621,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libgomp/configure.orig libgomp/configure
--- libgomp/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libgomp/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7649,6 +7649,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libhsail-rt/configure.orig libhsail-rt/configure
--- libhsail-rt/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libhsail-rt/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7457,6 +7457,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libitm/configure.orig libitm/configure
--- libitm/configure.orig	2020-07-23 08:35:19.000000000 +0200
+++ libitm/configure	2020-08-01 14:51:35.000000000 +0200
@@ -8280,6 +8280,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libobjc/configure.orig libobjc/configure
--- libobjc/configure.orig	2020-07-23 08:35:19.000000000 +0200
+++ libobjc/configure	2020-08-01 14:51:35.000000000 +0200
@@ -6967,6 +6967,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur liboffloadmic/configure.orig liboffloadmic/configure
--- liboffloadmic/configure.orig	2020-07-23 08:35:19.000000000 +0200
+++ liboffloadmic/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7915,6 +7915,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur liboffloadmic/plugin/configure.orig liboffloadmic/plugin/configure
--- liboffloadmic/plugin/configure.orig	2020-07-23 08:35:19.000000000 +0200
+++ liboffloadmic/plugin/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7295,6 +7295,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libphobos/configure.orig libphobos/configure
--- libphobos/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libphobos/configure	2020-08-01 14:51:35.000000000 +0200
@@ -8132,6 +8132,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libquadmath/configure.orig libquadmath/configure
--- libquadmath/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libquadmath/configure	2020-08-01 14:51:36.000000000 +0200
@@ -7271,6 +7271,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libsanitizer/configure.orig libsanitizer/configure
--- libsanitizer/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ libsanitizer/configure	2020-08-01 14:51:35.000000000 +0200
@@ -8846,6 +8846,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libssp/configure.orig libssp/configure
--- libssp/configure.orig	2020-07-23 08:35:19.000000000 +0200
+++ libssp/configure	2020-08-01 14:51:35.000000000 +0200
@@ -7453,6 +7453,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libstdc++-v3/configure.orig libstdc++-v3/configure
--- libstdc++-v3/configure.orig	2020-07-23 08:35:19.000000000 +0200
+++ libstdc++-v3/configure	2020-08-01 14:51:35.000000000 +0200
@@ -8388,6 +8388,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur libvtv/configure.orig libvtv/configure
--- libvtv/configure.orig	2020-07-23 08:35:19.000000000 +0200
+++ libvtv/configure	2020-08-01 14:51:35.000000000 +0200
@@ -8747,6 +8747,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur lto-plugin/configure.orig lto-plugin/configure
--- lto-plugin/configure.orig	2020-07-23 08:35:19.000000000 +0200
+++ lto-plugin/configure	2020-08-01 14:51:35.000000000 +0200
@@ -8431,6 +8431,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;
diff -Nur zlib/configure.orig zlib/configure
--- zlib/configure.orig	2020-07-23 08:35:54.000000000 +0200
+++ zlib/configure	2020-08-01 14:51:35.000000000 +0200
@@ -6842,6 +6842,8 @@
 	10.[012][,.]*)
 	  _lt_dar_allow_undefined='${wl}-flat_namespace ${wl}-undefined ${wl}suppress' ;;
 	10.*)
+          _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
+        11.*)
 	  _lt_dar_allow_undefined='${wl}-undefined ${wl}dynamic_lookup' ;;
       esac
     ;;