diff -ruN orig/Portfile new/Portfile
--- orig/Portfile	1970-01-01 03:00:00.000000000 +0300
+++ new/Portfile	2020-11-15 02:51:01.000000000 +0200
@@ -0,0 +1,61 @@
+# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
+
+PortSystem          1.0
+PortGroup           github 1.0
+PortGroup           ruby 1.0
+
+ruby.branches       2.7 2.6 2.5 2.4
+ruby.setup          ronn-ng 0.9.1 fetch
+github.setup        apjanke ronn-ng 0.9.1 v
+categories-append   www devel
+platforms           darwin
+license             MIT
+maintainers         nomaintainer
+supported_archs     noarch
+description         An updated fork of ronn. Build man pages from Markdown.
+long_description    Ronn-NG is a new, currently-maintained fork of the defunct \
+                    original Ronn project.  Ronn builds manuals. It converts \
+                    simple, human readable textfiles to roff for terminal \
+                    display, and also to HTML for the web.
+homepage            https://github.com/apjanke/ronn-ng
+
+
+checksums           rmd160  67dcde879fab39f84612fbddb2ebed097eb6bdc8 \
+                    sha256  41a7e9e621537654d1fd0cea5b60a0fca3c9d2a7ebddf6c7be8721612df88164 \
+                    size    68096
+
+if {${name} ne ${subport}} {
+    depends_lib-append  port:rb${ruby.suffix}-mustache \
+                        port:rb${ruby.suffix}-nokogiri \
+                        port:rb${ruby.suffix}-kramdown
+
+    patchfiles          patch-relax-dependencies.diff
+
+
+    use_configure       no
+
+    build.cmd           ${ruby.gem}
+    build.target        build
+    build.args          ronn-ng.gemspec
+
+    build {
+        command_exec build
+    }
+
+    destroot.cmd        ${ruby.gem}
+    destroot.target     install
+    destroot.args       --local --force --install-dir ${destroot}${ruby.gemdir}
+    destroot.env-append rake=${ruby.rake}
+    destroot.post_args  ronn-ng-${version}.gem
+
+    destroot {
+        command_exec destroot
+
+        set binDir ${destroot}${ruby.gemdir}/bin
+        if {[file isdirectory $binDir]} {
+            foreach file [readdir $binDir] {
+                file copy [file join $binDir $file] ${destroot}${ruby.bindir}
+            }
+        }
+    }
+}
diff -ruN orig/Portfile.orig new/Portfile.orig
--- orig/Portfile.orig	2020-11-15 02:52:45.000000000 +0200
+++ new/Portfile.orig	1970-01-01 03:00:00.000000000 +0300
@@ -1,59 +0,0 @@
-# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
-
-PortSystem          1.0
-PortGroup           github 1.0
-PortGroup           ruby 1.0
-
-ruby.branches       2.7 2.6 2.5 2.4
-ruby.setup          ronn-ng 0.8.2 fetch
-github.setup        apjanke ronn-ng 0.8.2 v
-categories-append   www devel
-platforms           darwin
-license             MIT
-maintainers         nomaintainer
-supported_archs     noarch
-description         An updated fork of ronn. Build man pages from Markdown.
-long_description    Ronn-NG is a new, currently-maintained fork of the defunct \
-                    original Ronn project.  Ronn builds manuals. It converts \
-                    simple, human readable textfiles to roff for terminal \
-                    display, and also to HTML for the web.
-homepage            https://github.com/apjanke/ronn-ng
-
-checksums           rmd160  2ba9f3985bc1c596990e0887d0ef30d396c1491a \
-                    sha256  de0e97051fd1b7b982b7593736827b505c1f7138b4ac520d3b02d42d7baccda8 \
-                    size    67152
-
-if {${name} ne ${subport}} {
-    depends_lib-append  port:rb${ruby.suffix}-mustache \
-                        port:rb${ruby.suffix}-nokogiri \
-                        port:rb${ruby.suffix}-rdiscount
-
-    patchfiles          patch-relax-dependencies.diff
-
-    use_configure       no
-
-    build.cmd           ${ruby.gem}
-    build.target        build
-    build.args          ronn-ng.gemspec
-
-    build {
-        command_exec build
-    }
-
-    destroot.cmd        ${ruby.gem}
-    destroot.target     install
-    destroot.args       --local --force --install-dir ${destroot}${ruby.gemdir}
-    destroot.env-append rake=${ruby.rake}
-    destroot.post_args  ronn-ng-${version}.gem
-
-    destroot {
-        command_exec destroot
-
-        set binDir ${destroot}${ruby.gemdir}/bin
-        if {[file isdirectory $binDir]} {
-            foreach file [readdir $binDir] {
-                file copy [file join $binDir $file] ${destroot}${ruby.bindir}
-            }
-        }
-    }
-}
diff -ruN orig/files/patch-relax-dependencies.diff new/files/patch-relax-dependencies.diff
--- orig/files/patch-relax-dependencies.diff	2020-11-15 01:58:53.000000000 +0200
+++ new/files/patch-relax-dependencies.diff	1970-01-01 03:00:00.000000000 +0300
@@ -1,22 +0,0 @@
-Description: Relax gem dependencies
-  as Debian unstable has already newer version of them...
-Author: Cédric Boutillier <boutil@debian.org>
-Last-Update: 2020-11-15
-Forwarded: not-needed
-
-
---- ronn-ng.gemspec
-+++ ronn-ng.gemspec
-@@ -107,9 +107,9 @@
-   s.test_files = s.files.select { |path| path =~ /^test\/.*_test.rb/ }
- 
-   s.extra_rdoc_files = %w[LICENSE.txt AUTHORS]
--  s.add_dependency 'kramdown',    '~> 2.1'
--  s.add_dependency 'mustache',    '~> 0.7', '>= 0.7.0'
--  s.add_dependency 'nokogiri',    '~> 1.9', '>= 1.9.0'
-+  s.add_dependency 'kramdown',    '>= 2.1.0'
-+  s.add_dependency 'mustache',    '>= 0.7.0'
-+  s.add_dependency 'nokogiri',    '>= 1.9.0'
-   s.add_development_dependency 'rack',      '~> 2.0',  '>= 2.0.6'
-   s.add_development_dependency 'rake',      '~> 12.3', '>= 12.3.0'
-   s.add_development_dependency 'rubocop',   '~> 0.60', '>= 0.57.1'
diff -ruN orig/files/patch-relax-dependencies.diff.orig new/files/patch-relax-dependencies.diff.orig
--- orig/files/patch-relax-dependencies.diff.orig	1970-01-01 03:00:00.000000000 +0300
+++ new/files/patch-relax-dependencies.diff.orig	2020-11-15 03:00:39.000000000 +0200
@@ -0,0 +1,22 @@
+Description: Relax gem dependencies
+  as Debian unstable has already newer version of them...
+Author: Cédric Boutillier <boutil@debian.org>
+Last-Update: 2019-02-06
+Forwarded: not-needed
+
+
+--- ronn-ng.gemspec
++++ ronn-ng.gemspec
+@@ -107,9 +107,9 @@
+   s.test_files = s.files.select { |path| path =~ /^test\/.*_test.rb/ }
+ 
+   s.extra_rdoc_files = %w[LICENSE.txt AUTHORS]
+-  s.add_dependency 'mustache',    '~> 0.7', '>= 0.7.0'
+-  s.add_dependency 'nokogiri',    '~> 1.9', '>= 1.9.0'
+-  s.add_dependency 'rdiscount',   '~> 2.0', '>= 2.0.7'
++  s.add_dependency 'mustache',    '>= 0.7.0'
++  s.add_dependency 'nokogiri',    '>= 1.9.0'
++  s.add_dependency 'rdiscount',   '>= 2.0.7'
+   s.add_development_dependency 'rack',      '~> 2.0',  '>= 2.0.6'
+   s.add_development_dependency 'rake',      '~> 12.3', '>= 12.3.0'
+   s.add_development_dependency 'rubocop',   '~> 0.60', '>= 0.57.1'